back-office-app/routes/web.php
<?php

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

use App\Http\Controllers\ItemTypesController;

Auth::routes();
Route::get('/', 'CatalogController@index')->name('catalog.index');
Route::get('/catalog/{id}/detail', 'CatalogController@detail')->name('catalog.detail');

Route::group(['middleware' => ['auth']], function(){
    Route::prefix('admin')->group(function () {
        Route::resource('dashboard', 'DashboardController');
        Route::resource('brands', 'BrandController');
        Route::resource('categories', 'CategoriesController');
        Route::resource('products', 'ProductsController');
        Route::resource('itemtypes', 'ItemTypesController');
        Route::get('export/itemtypes', 'ItemTypesController@fileExport')->name('itemtypes-export');
        Route::get('pdf/itemtypes', 'ItemTypesController@pdf')->name('itemtypes-pdf');
        Route::get('export/brands', 'BrandController@fileExport')->name('brands-export');
        Route::get('pdf/brands', 'BrandController@pdf')->name('brands-pdf');
        Route::get('export/categories', 'CategoriesController@fileExport')->name('categories-export');
        Route::get('pdf/categories', 'CategoriesController@pdf')->name('categories-pdf');
        Route::get('export/products', 'ProductsController@fileExport')->name('products-export');
        Route::get('pdf/products', 'ProductsController@pdf')->name('products-pdf');
        Route::resource('profile', 'ProfileController');
    });
});
Route::get('/admin', function () {
    return view('auth.login');
});

back-office-app/app/Models/Products.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Model;

class Products extends Model
{
    protected $table = "products";
    protected $fillable = ['name', 'photo', 'description', 'price', 'stock', 'itemtype_id'];
    protected $with = array('itemtypes');

    public function itemtypes()
    {
        return $this->belongsTo(Itemtypes::class, 'itemtype_id', 'id');
    }
}

back-office-app/app/Http/Controllers/ProductsController.php
<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use App\Models\Products;
use App\Models\Itemtypes;
use App\Models\Categories;
use App\Models\Brands;
use File;
use Alert;
use Maatwebsite\Excel\Facades\Excel;
use PDF;
use App\Exports\ProductsExport;

class ProductsController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index(Request $request)
    {
        // $products = new Products;
        $products = Products::with('itemtypes')->paginate(5);
        if($request->search){
            $products = Products::with('itemtypes')->where('name','like', '%'.$request->search.'%')->orWhere('description','like', '%'.$request->search.'%')->paginate(5);
        }
        return view('products.index', ['products' => $products, 'search' => $request->search]);
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        $products = Products::all();
        $itemtypes = Itemtypes::all();
        $categories = Categories::all();
        $brands = Brands::all();
        return view('products.create', ['products' => $products, 'itemtypes' => $itemtypes, 'categories' => $categories, 'brands' => $brands]);
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        $request->validate([
            'name' => 'required',
            'description' => 'required',
            'name_photo' => 'required',
            'price' => 'required|integer',
            'stock' => 'required|integer',
            'itemtype_id' => 'required'
        ]);

        $products = new Products;
        $products->name = $request->name;
        $products->description = $request->description;
        $products->price = $request->price;
        $products->photo = $request->photo;
        $products->stock = $request->stock;
        $products->itemtype_id = $request->itemtype_id;
        $name_photo = $request->name_photo;
        $photo = time().'.'.$name_photo->getClientOriginalExtension();
        $name_photo->move('images/', $photo);
        $products->photo = $photo;
        $products->save();
        Alert::success('Congrats', 'Product Succesfully Saved');
        return redirect(route('products.index'));
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        //
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        $products = Products::find($id);
        $itemtypes = Itemtypes::all();
        $categories = Categories::all();
        $brands = Brands::all();
        return view('products.edit', ['products' => $products, 'itemtypes' => $itemtypes, 'categories' => $categories, 'brands' => $brands]);
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
        $request->validate([
            'name' => 'required',
            'description' => 'required',
            'name_photo' => 'required',
            'price' => 'required|integer',
            'stock' => 'required|integer',
            'itemtype_id' => 'required'
        ]);

        $products = Products::find($id);
        $products->name = $request->name;
        $products->description = $request->description;
        $products->price = $request->price;
        $products->photo = $request->photo;
        $products->stock = $request->stock;
        $products->itemtype_id = $request->itemtype_id;
        $name_photo = $request->name_photo;
        $photo = time().'.'.$name_photo->getClientOriginalExtension();
        $name_photo->move('images/', $photo);
        $products->photo = $photo;
        $products->update();
        Alert::success('Congrats', 'Product Succesfully Updated');
        return redirect(route('products.index'));
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        $item = Products::find($id);
        $item->delete();
        Alert::info('Congrats', 'Product Succesfully Deleted');
        return redirect(route('products.index'));
    }

    public function fileExport()
    {
        return Excel::download(new ProductsExport, 'products-collection.xlsx');
    }

    public function pdf()
    {
    	$items = Products::all();
    	$pdf = PDF::loadview('products.pdf',['items'=>$items]);
    	return $pdf->download('products.pdf');
    }
}

back-office-app/resources/views/products/create.blade.php
@extends('layouts.master')

@section('title')
Categories Page
@endsection

@section('content')
<a href="{{URL::previous()}}" class="btn btn-primary mb-3"><i class="fa fa-arrow-left"></i> Kembali</a>
<div class="card" style="border:none;">
  <div class="card-body">
    <div class="col-12 p-0">
      <form method="post" enctype="multipart/form-data" action="{{route('products.index')}}">
        @csrf
        <div class="form-group">
          <label for="name">Name</label>
          <input type="text" class="form-control" id="name" name="name">
        </div>
        @error('name')
          <div class="alert alert-danger">{{ $message }}</div>
        @enderror
        <div class="form-group">
            <label for="name_photo">Photo</label>
            <input type="file" class="form-control" name="name_photo">
          </div>
        @error('photo')
            <div class="alert alert-danger">{{ $message }}</div>
        @enderror
        <div class="form-group">
            <label for="description">Description</label>
            <input type="text" class="form-control" id="description" name="description">
          </div>
        @error('description')
            <div class="alert alert-danger">{{ $message }}</div>
        @enderror
        <div class="form-group">
            <label for="price">Price</label>
            <input type="text" class="form-control" id="price" name="price">
          </div>
        @error('price')
            <div class="alert alert-danger">{{ $message }}</div>
        @enderror
          <div class="form-group">
            <label for="stock">Stock</label>
            <input type="text" class="form-control" id="stock" name="stock">
          </div>
        @error('stock')
            <div class="alert alert-danger">{{ $message }}</div>
        @enderror
        <div class="form-group">
          <label for="name">Item Types</label>
          <select name="itemtype_id" id="itemtype_id" class="form-control">
            <option selected>Choose...</option>
            @foreach($itemtypes as $item)
            <option value="{{$item->id}}">{{$item->name}}</option>
            @endforeach
          </select>
          @error('brand_id')
              <div class="alert alert-danger">
              <strong>{{ $message }}</strong>
              </div>
          @enderror
        </div>
        <div class="form-group row">
          <div class="col-sm-10">
            <button type="submit" class="btn btn-success">Simpan</button>
            <a href="{{URL::previous()}}" class="btn btn-warning text-white">Batal</a>
          </div>
        </div>
      </form>
    </div>
  </div>
</div>
@endsection

back-office-app/resources/views/products/edit.blade.php
@extends('layouts.master')

@section('title')
Categories Page
@endsection

@section('content')
<a href="{{URL::previous()}}" class="btn btn-primary mb-3"><i class="fa fa-arrow-left"></i> Kembali</a>
<div class="card" style="border:none;">
  <div class="card-body">
    <div class="col-12 p-0">
      <form method="post" enctype="multipart/form-data" action="{{route('products.update',$products->id)}}">
        @csrf
        @method('put')
        <div class="form-group">
          <label for="name">Name</label>
          <input type="text" value="{{$products->name}}" class="form-control" id="name" name="name">
        </div>
        @error('name')
          <div class="alert alert-danger">{{ $message }}</div>
        @enderror
        <div class="form-group">
            <label for="name_photo">Photo</label>
            <input type="file" value="{{$products->photo}}" class="form-control" name="name_photo">
          </div>
        @error('photo')
            <div class="alert alert-danger">{{ $message }}</div>
        @enderror
        <div class="form-group">
            <label for="description">Description</label>
            <input type="text" value="{{$products->description}}" class="form-control" id="description" name="description">
          </div>
        @error('description')
            <div class="alert alert-danger">{{ $message }}</div>
        @enderror
        <div class="form-group">
            <label for="price">Price</label>
            <input type="text" value="{{$products->price}}" class="form-control" id="price" name="price">
          </div>
        @error('price')
            <div class="alert alert-danger">{{ $message }}</div>
        @enderror
          <div class="form-group">
            <label for="stock">Stock</label>
            <input type="text" value="{{$products->stock}}" class="form-control" id="stock" name="stock">
          </div>
        @error('stock')
            <div class="alert alert-danger">{{ $message }}</div>
        @enderror
          <div class="form-group">
            <label for="itemtype_id">Itemtype</label>
            <input type="text" value="{{$products->itemtype_id}}" class="form-control" id="itemtype_id" name="itemtype_id">
          </div>
        @error('itemtype_id')
            <div class="alert alert-danger">{{ $message }}</div>
        @enderror
        <div class="form-group row">
          <div class="col-sm-10">
            <button type="submit" class="btn btn-success">Simpan</button>
            <a href="{{URL::previous()}}" class="btn btn-warning text-white">Batal</a>
          </div>
        </div>
      </form>
    </div>
  </div>
</div>
@endsection

back-office-app/resources/views/products/index.blade.php
@extends('layouts.master')

@section('title')
Product Page
@endsection

@section('content')
<div class="container-fluid">
    <form method="get" action="{{ route('products.store') }}">
        <div class="row">
            <div class="col-2">
                <a style="width: 100%;" href="{{route('products.create')}}" class="btn btn-primary btn-md mb-3"><i class="fa fa-plus" aria-hidden="true"></i> Create Data</a>
            </div>
            <div class="col-4 p-0">
                <div class="form-group">
                    <input type="text" class="form-control" id="search" name="search" placeholder="Search By Name" value={{ $search }}>
                </div>
            </div>
            <div class="col-2">
                <button style="width: 100%;" type="submit" class="btn btn-success btn-md mb-3"><i class="fa fa-search" aria-hidden="true"></i> Search</button>
            </div>
            <div class="col-2">
                <a style="width: 100%;" href="{{route('products-export')}}" class="btn btn-warning btn-md mb-3">Export as XLS</a>
            </div>
            <div class="col-2">
                <a style="width: 100%;" href="{{route('products-pdf')}}" class="btn btn-info btn-md mb-3">Export as PDF</a>
            </div>
        </div>
    <form>
    <div class="card shadow mb-4">
        <div class="card-header py-3">
            <h6 class="m-0 font-weight-bold text-primary">DataTables Example</h6>
        </div>
        <div class="card-body">
            <div class="table-responsive">
                <table class="table table-bordered" id="dataTable" width="100%" cellspacing="0">
                    <thead>
                        <tr>
                            <th>No</th>
                            <th>Name</th>
                            <th>Photo</th>
                            <th>Description</th>
                            <th>Price</th>
                            <th>Stock</th>
                            <th>Itemtype</th>
                            <th>Action</th>
                        </tr>
                    </thead>
                    <tbody>
                        @foreach ($products as $key => $item)
                        <tr>
                            <td>{{$key + 1}}</td>
                            <td>{{ $item->name }}</td>
                            <td>{{ $item->photo }}</td>
                            <td>{{ $item->description }}</td>
                            <td>{{ $item->price }}</td>
                            <td>{{ $item->stock }}</td>
                            <td>{{ $item->itemtypes->name }}</td>
                            <td>
                                <form action="{{route('products.destroy', $item->id)}}" method="post">
                                    @csrf
                                    @method('delete')
                                    <a href="{{route('products.edit', $item->id)}}" class="btn btn-warning btn-sm text-white"><i class="fa fa-pen"></i></a>
                                    <button onclick="return confirm('Are you sure to delete this data?')" class="btn btn-danger btn-sm"><i class="fa fa-trash"></i></button>
                                </form>
                            </td>
                        </tr>
                        @endforeach
                    </tbody>
                </table>
            </div>
            <div class="float-right">
                {{ $products->appends(request()->query())->links() }}
            </div>
        </div>
    </div>
</div>
@endsection

back-office-app/resources/views/products/pdf.blade.php
<!DOCTYPE html>
<html>
<head>
	<title>Products</title>
	<link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.3.1/css/bootstrap.min.css" integrity="sha384-ggOyR0iXCbMQv3Xipma34MD+dH/1fQ784/j6cY/iJTQUOhcWr7x9JvoRxT2MZw1T" crossorigin="anonymous">
</head>
<body>
	<style type="text/css">
		table tr td,
		table tr th{
			font-size: 9pt;
		}
	</style>

	<table class='table table-bordered'>
		<thead>
			<tr>
                <th>No</th>
                <th>Product Name</th>
                <th>Product Photo</th>
                <th>Product Description</th>
                <th>Product Price</th>
                <th>Product Stock</th>
                <th>Product Itemtype</th>
            </tr>
		</thead>
		<tbody>
			@php $i=1 @endphp
            @foreach($items as $key => $item)
                <tr>
                    <td>{{$i++}}</td>
                    <td>{{ $item->name }}</td>
                    <td>{{ $item->photo }}</td>
                    <td>{{ $item->description }}</td>
                    <td>{{ $item->price }}</td>
                    <td>{{ $item->stock }}</td>
                    <td>{{ $item->itemtype_id }}</td>
                </tr>
            @endforeach
		</tbody>
	</table>

</body>
</html>